Package org.optaplanner.core.impl.heuristic.selector.common.iterator

## Class AbstractOriginalChangeIterator<S extends Move>

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.selector.common.iterator.SelectionIterator<S>
  - - org.optaplanner.core.impl.heuristic.selector.common.iterator.UpcomingSelectionIterator<S>
    - - org.optaplanner.core.impl.heuristic.selector.common.iterator.AbstractOriginalChangeIterator<S>

- All Implemented Interfaces:
    `Iterator<S>`

      public abstract class AbstractOriginalChangeIterator<S extends Move>
      extends UpcomingSelectionIterator<S>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.common.iterator.UpcomingSelectionIterator

      `hasUpcomingSelection, upcomingCreated, upcomingSelection`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractOriginalChangeIterator​(EntitySelector entitySelector, ValueSelector valueSelector)` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected S` | `createUpcomingSelection()` |
    `protected abstract S` | `newChangeSelection​(Object entity, Object toValue)` |

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.common.iterator.UpcomingSelectionIterator

      `hasNext, next, noUpcomingSelection, toString`

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.common.iterator.SelectionIterator

      `remove`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining`

- - ### Constructor Detail

    - #### AbstractOriginalChangeIterator

          public AbstractOriginalChangeIterator​(EntitySelector entitySelector,
                                                ValueSelector valueSelector)

  - ### Method Detail

    - #### createUpcomingSelection

          protected S createUpcomingSelection()

      Specified by:
        `createUpcomingSelection` in class `UpcomingSelectionIterator<S extends Move>`

    - #### newChangeSelection

          protected abstract S newChangeSelection​(Object entity,
                                                  Object toValue)